/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package app.bachelorproject.auth;

import java.util.Properties;
import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.mail.Authenticator;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import org.eclipse.microprofile.config.inject.ConfigProperty;

/**
 *
 * @author marti, mikael, https://www.baeldung.com/java-email
 */
@Stateless
public class ForgotPasswordMail {
    @Inject
    @ConfigProperty(name = "mail.smtp.host")
    String smtpHost;
    
    @Inject
    @ConfigProperty(name = "mail.smtp.username")
    String smtpUser;

    @Inject
    @ConfigProperty(name = "mail.smtp.password")
    String smtpPassword;
    
    public void Send(String pw, String mail) throws AddressException, MessagingException{
        Properties prop = new Properties();
        prop.put("mail.smtp.auth", true);
        prop.put("mail.smtp.starttls.enable", "true");
        prop.put("mail.smtp.host", smtpHost);
        prop.put("mail.smtp.port", "587");
        
        Session session = Session.getInstance(prop, new Authenticator() {
                protected PasswordAuthentication getPasswordAuthentication() {
                    return new PasswordAuthentication(smtpUser, smtpPassword);
                }
            });
        
        Message message = new MimeMessage(session);
        message.setFrom(new InternetAddress(smtpUser));
        message.setRecipients(
                //----------------------------------------------------
        Message.RecipientType.TO, InternetAddress.parse(mail));
                //----------------------------------------------------
        message.setSubject("Mail Subject");
        
        String msg = "This is an automatically generated new password.";
        String msg2 = "Please change your password as soon as possible.";
        
        StringBuilder sb = new StringBuilder();
        sb.append(msg).append(System.lineSeparator());
        sb.append(pw).append(System.lineSeparator());
        sb.append(msg2).append(System.lineSeparator());
        
        message.setText(sb.toString());

        MimeBodyPart mimeBodyPart = new MimeBodyPart();
        mimeBodyPart.setContent(sb.toString(), "text/html");

        Multipart multipart = new MimeMultipart();
        multipart.addBodyPart(mimeBodyPart);
        

        //message.setContent(multipart);
        message.saveChanges();

        Transport.send(message);
    }
}
