/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package bachelorprojectfavourites;

import app.bachelorproject.auth.User;
import bachelorprojectstock.Stock;
import javax.json.bind.annotation.JsonbTransient;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import lombok.AllArgsConstructor;
import lombok.Data;

/**
 *
 * @author marti
 */
@Entity
@Data
@AllArgsConstructor
@NamedQuery(name="FavouriteStockEntity.findAllFavourites",
        query = "select f from FavouriteStockEntity f")
@NamedQuery(name="FavouriteStockEntity.findFavouritesByUser",
        query = "select f from FavouriteStockEntity f where f.user.userid = :userid")
public class FavouriteStockEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name ="id")
    int id;
    
    @JsonbTransient
    @ManyToOne
    @JoinColumn(name="user", referencedColumnName = "userid")
    User user;
    
    @ManyToOne
    @JoinColumn(name="stock", referencedColumnName = "stockId")
    Stock stock;
    
    public FavouriteStockEntity(){
        
    }
    
    public FavouriteStockEntity(User user, Stock stock){
        this.user = user;
        this.stock = stock;
    }
    
}
