/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package bachelorprojectlog;

import app.bachelorproject.auth.User;
import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import javax.json.bind.annotation.JsonbTransient;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.Temporal;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 *
 * @author marti
 */

@Entity
@Data
@AllArgsConstructor
@NamedQuery(name = "LogEntry.findAllLogEntries",
        query = "select l from LogEntry l")
@NamedQuery(name = "LogEntity.findByUserId",
        query = "select l from LogEntry l, User u where u.userid = :userid " + 
                "and (l.user = u) and (l.transaksjonsType = 'KJØPT' "+
                 "or l.transaksjonsType = 'SALG')")
public class LogEntry implements Serializable {

        
    @Id
    @Column(name="id")
    int Id;
    
    
    @Temporal(javax.persistence.TemporalType.DATE)
    Calendar handelsDag;
    
    @Temporal(javax.persistence.TemporalType.DATE)
    Calendar oppgjørsDag;
    
    String transaksjonsType;
    String verdiPapir;
    int antall;
    double kurs;
    double belop;
    String resultat;
    List<String> tags;
    
    @JsonbTransient
    @ManyToOne
    @JoinColumn(name="user", referencedColumnName = "userid")
    User user;
    
    String comment;
    

    
    public LogEntry() {
    }


    public LogEntry(int id, User user, Calendar handelsDag, Calendar oppgjørsDag, String transaksjonsType, String verdiPapir, int antall, double kurs, double belop, String resultat, String comment){
        this.Id = id;
        this.user = user;
        this.handelsDag = handelsDag;
        this.oppgjørsDag = oppgjørsDag;
        this.transaksjonsType = transaksjonsType;
        this.verdiPapir = verdiPapir;
        this.antall = antall;
        this.kurs = kurs;
        this.belop = belop;
        this.resultat = resultat;
        this.comment = comment;
        
    }

    
}
