package rssreader;

import app.bachelorproject.auth.Group;
import java.net.*;
import java.io.*;
import javax.annotation.security.DeclareRoles;
import javax.ejb.Stateless;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;


@Path("rss")
@Stateless
@DeclareRoles({Group.USER, Group.ADMIN})
public class RssReader {
    
    @Context
    SecurityContext sc;
    
    
    @GET
    @Path("getrss")
    @Produces(MediaType.APPLICATION_JSON)
    public Response getAllTags() throws Exception{
        System.out.println("RSS");
        
        return Response.ok(testRun()).build();
    }
    

    public String testRun() throws Exception {
        URL rssfeed = new URL("https://e24.no/rss2/?seksjon=boers-og-finans");
        BufferedReader in = new BufferedReader(new InputStreamReader(rssfeed.openStream()));
        String rssfeeds = in.readLine();
        in.close();
        String[] listofelements;
        listofelements = rssfeeds.split("<item>");
        String feedBody = "";
        for (int i = 1; i < 6; i++) {
            String[] title = listofelements[i].split("<title>");
            String[] titles = title[1].split("</title>");
            String[] pubdate = listofelements[i].split("<pubDate>");
            String[] listofdates = pubdate[1].split("</pubDate>");
            String[] description = listofelements[i].split("<description>");
            String[] listofdescriptions = description[1].split("</description>");
            String[] urllink = listofelements[i].split("<link>");
            String[] url = urllink[1].split("</link>");
            String[] imagelink = listofelements[i].split("<image>");
            String[] link = imagelink[1].split("</image>");
            feedBody = (feedBody + "<div class=\"stocksarticle\"><h1><a href=\"" + url[0] + "\">" + titles[0] + "</h1><img src=\"" + link[0] + "\"></div>");
            //feedBody = (feedBody + "<div class=\"stocksarticle\"><h1><a href=\"" + url[0] + "\">" + titles[0] + "</h1><p><a href=\"" + url[0] + "\">"
              //                          + listofdescriptions[0] + "</p><img src=\"" + link[0] + "\"></div>" + "\\n");
            System.out.println(feedBody);
        }
        return feedBody;
    }
}
