const urlSR ='http://158.38.101.196:9000/BachelorTestOne-1.0/api/stock/getstocks';
const urlFR ='http://158.38.101.196:9000/BachelorTestOne-1.0/api/favouritestocks/getfavourites';
const urlFU ='http://158.38.101.196:9000/BachelorTestOne-1.0/api/favouritestocks/create';
const urlFD ='http://158.38.101.196:9000/BachelorTestOne-1.0/api/favouritestocks/remove';


let response = []
let favorites = []
let currentList = [];
let currentFavoriteList = [];
let stocksTable = document.getElementById('stockTable')
let favoriteTable = document.getElementById('favoriteTable')
localStorage.removeItem("stockName")

 getStocks();
 getFavorites();


 function getStocks(){
    const Http = new XMLHttpRequest();
    Http.open("GET",urlSR);
    Http.setRequestHeader("Content-Type","application/json;Charset=UTF-8")
    Http.setRequestHeader("Authorization","Bearer " + localStorage.getItem("key"));
    Http.send()
    Http.onreadystatechange = ()=>{
        response = JSON.parse(Http.responseText);
        updateAvailableStocks(response);
    }
 }


 function getFavorites(){
    const Http = new XMLHttpRequest();
    Http.open("GET",urlFR);
    Http.setRequestHeader("Content-Type","application/json;Charset=UTF-8")
    Http.setRequestHeader("Authorization","Bearer " + localStorage.getItem("key"));
    Http.send()
    Http.onreadystatechange = ()=>{
        favorites = JSON.parse(Http.responseText);
        updateFavoriteStocks(favorites);
    }
 }


function updateAvailableStocks(response){
    stocksTable.innerHTML = '';
    currentList = response;

    for(let i = 0; i<response.length; i++){
        let stocks = `<tr>
                        <td>${currentList[i].tag}</td>
                        <td onclick= sendToArticle(1,${[i]}) style="cursor: pointer">${currentList[i].name}</td>
                        <td>${currentList[i].market}</td>
                        <th>
                        <button onclick="addFavorite(${[i]})">Legg til i favoritter</button>
                        </th>
                      </tr>`

        stocksTable.innerHTML +=stocks;
    }
}

function updateFavoriteStocks(favorites){
    favoriteTable.innerHTML = '';
    currentFavoriteList = favorites;
    
        for (let i = 0; i < currentFavoriteList.length; i++) {
            let row = `<tr>
                        <td>${currentFavoriteList[i].stock.tag}</td>
                        <td onclick= sendToArticle(2,${[i]}) style="cursor: pointer">${currentFavoriteList[i].stock.name}</td>
                        <td>${currentFavoriteList[i].stock.market}</td>
                        <th>
                            <button onclick="removeFavorite(${[i]})">Fjern fra favoritter</button>
                        </th>
                   </tr>`
            favoriteTable.innerHTML += row;
        }
}

function addFavorite(i){
     const Http = new XMLHttpRequest();
     Http.open("POST",urlFU)
     Http.setRequestHeader("Content-Type","application/x-www-form-urlencoded;Charset=UTF-8")
     Http.setRequestHeader("Authorization","Bearer " + localStorage.getItem("key"));
     Http.send("sid="+currentList[i].stockId);
     Http.onreadystatechange = ()=>{
         getFavorites();
     }

}

function removeFavorite(i){
    const Http = new XMLHttpRequest();
    Http.open("POST",urlFD);
    Http.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=UTF-8")
    Http.setRequestHeader("Authorization","Bearer " + localStorage.getItem("key"));
    console.log(currentFavoriteList[i].id);
    Http.send("fid=" + currentFavoriteList[i].id)
    Http.onreadystatechange = ()=>{
        getFavorites();
    }
    document.getElementById("searchFavorites").value="";

}
function sendToArticle(list,i){
    if(list == 1){
        localStorage.setItem("stockName",currentList[i].name)
    }
    else{
        localStorage.setItem("stockName",currentFavoriteList[i].stock.name)
    }
    window.location.href="../stockandarticles/stocksandarticles.html";
}

$('#searchbar').on('keyup',function(){
    let value = $(this).val();
    let data = searchStockTable(value,response);
    updateAvailableStocks(data)
})

$('#searchFavorites').on('keyup',function(){
    let value = $(this).val();
    let data = searchFavouriteTable(value,favorites);
    updateFavoriteStocks(data)
})

function searchStockTable(value, data){
    let filteredData = [];
    for(let i=0; i< data.length;i++){
        let tag = data[i].tag.toLowerCase();
        let name = data[i].name.toLowerCase();
        let market = data[i].market.toLowerCase();
        if(tag.includes(value) || name.includes(value) || market.includes(value)){
            filteredData.push(data[i])
        }
    }
    return filteredData
}
function searchFavouriteTable(value, data){
    let filteredData = [];
    for(let i=0; i< data.length;i++){
        let tag = data[i].stock.tag.toLowerCase();
        let name = data[i].stock.name.toLowerCase();
        let market = data[i].stock.market.toLowerCase();
        if(tag.includes(value) || name.includes(value) || market.includes(value)){
            filteredData.push(data[i])
        }
    }
    return filteredData
}

