const urlAR = 'http://158.38.101.196:9000/BachelorTestOne-1.0/api/articles/getallarticleinfo';
let today = new Date()
let present = today.getFullYear() + '-' + 0 + (today.getMonth() + 1) + '-' + today.getDate();
let lastMonth = today.getFullYear() + '-' + 0 + today.getMonth() + '-' + today.getDate();
let response = []
let responseForArticle = []
let popularStocks = []
let popularStocksLastMonth = []
getArticle()

function getArticle() {
    const Http = new XMLHttpRequest();
    Http.open("GET", urlAR);
    Http.setRequestHeader("Content-Type", "application/json;Charset=UTF-8")
    Http.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("key"));
    Http.send()
    Http.onreadystatechange = () => {
        response = JSON.parse(Http.responseText);
        if (document.URL.includes("/index")) {
            updateArticleList();
        } else {
            listAvailableArticles();
        }
    }
}

function getListOfPopularStocks() {
    let countToday = {}
    let countLastMonth = {}
    let sortedListToday = []
    let sortedListLastMonth = []
    let str = []
    response.map(function (arr, i) {
        if (arr.date == present) {
            countToday[arr.stockName] = (+countToday[arr.stockName] || 0) + 1
        }
        if (lastMonth <= arr.date && arr.date <= present) {
            countLastMonth[arr.stockName] = (+countLastMonth[arr.stockName] || 0) + 1
        }
    });
    // count.sort((a, b) => (a.stockName > b.stockName) ? 1 : -1)
    for (stockName in countToday) {
        sortedListToday.push({"stockName": stockName, "nrOfArticles": countToday[stockName]})
    }
    for (stockName in countLastMonth) {
        sortedListLastMonth.push({"stockName": stockName, "nrOfArticles": countLastMonth[stockName]})
    }
    sortedListToday.sort(function (a, b) {
        return b.nrOfArticles - a.nrOfArticles
    })
    sortedListLastMonth.sort(function (a, b) {
        return b.nrOfArticles - a.nrOfArticles
    })
    return [sortedListToday, sortedListLastMonth];
}

let articleTable = document.getElementById('index_aside');

function sendToArticle(list, i) {
    if (list == 1) {
        localStorage.setItem("stockName", popularStocks[i].stockName)
    } else {
        localStorage.setItem("stockName", popularStocksLastMonth[i].stockName)
    }
    window.location.href = "stockandarticles/stocksandarticles.html";
}

function updateArticleList() {
    let stocksToday = 0
    let lists = getListOfPopularStocks()
    popularStocks = lists[0]
    popularStocksLastMonth = lists[1]
    articleTable.innerHTML = '<h2>5 Mest populære aksjer idag</h2>';
    let y = 0;
    while (y < popularStocks.length && y < 5) {
        let stockTitle = `<h3 onclick=sendToArticle(1,${y}) style="cursor: pointer">
            ${popularStocks[y].stockName}: ${popularStocks[y].nrOfArticles} artikel funnet idag. </h3>`
        articleTable.innerHTML += stockTitle;
        stocksToday++
        y++;
    }
    if (stocksToday == 0) {
        articleTable.innerHTML += "<p>Ingen nye artikler idag</p>"
    }
    articleTable.innerHTML += '<h2>5 Mest populære aksjer siste måned</h2>';
    let x = 0;
    while (x < popularStocksLastMonth.length && x < 5) {
        let stockTitle = `<h3 onclick=sendToArticle(2,${x}) style="cursor: pointer">
            ${popularStocksLastMonth[x].stockName}: ${popularStocksLastMonth[x].nrOfArticles} artikler funnet den siste måneden. </h3>`
        articleTable.innerHTML += stockTitle;
        x++;
    }
}

function listAvailableArticles() {
    let availabeArticles = document.getElementById('AvailableArticles');
    availabeArticles.innerHTML = ""
    responseForArticle = response;
    responseForArticle.sort(function (a, b){return new Date(b.date) - new Date(a.date)})
        for (i = 0; i < responseForArticle.length; i++) {
        while (lastMonth <= responseForArticle[i].date && i<40) {
            let rating = "";
            if (responseForArticle[i].sentiment < 0) {
                rating = "badRating"
            } else if (responseForArticle[i].sentiment > 0) {
                rating = "goodRating"
            } else {
                rating = "rating"
            }
            let row = ` 
        <td>${responseForArticle[i].stockName}</td>
        <td><a href=${responseForArticle[i].url} target="_blank" style="cursor: pointer">${responseForArticle[i].title}</td>
        <td>${responseForArticle[i].date}</td>
        <td id="${rating}"></td>
        `
            availabeArticles.innerHTML += row;
            i++
        }
    }
}
