const url = 'http://158.38.101.196:9000/BachelorTestOne-1.0/api/articles/getarticlesforstock?stock=' + localStorage.getItem("stockName");
const testurl = 'http://158.38.101.196:9000/BachelorTestOne-1.0/api/articles/getarticlesforstock?stock=ABG SUNDAL COLLIER';

let stocksTable = document.getElementById('stockTable')
let articleGraph = document.getElementById('sentiment_graph')
var stockname = "Artikler for " + localStorage.getItem("stockName")
let currentList = [];
let popupdata = document.getElementById("popupSentiment");

window.onload(getarticleforstock())

function getarticleforstock() {
    document.getElementById("articlename").innerHTML = stockname
    const Http = new XMLHttpRequest();
    Http.open("GET", url);
    Http.setRequestHeader("Content-Type", "application/json;Charset=UTF-8")
    Http.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("key"));
    Http.send()
    Http.onreadystatechange = () => {
        response = JSON.parse(Http.responseText);
        updateAvailableStocks(response);
    }
}

function updateAvailableStocks(response) {
    stocksTable.innerHTML = '';
    currentList = response;
    currentList.sort(function (a, b) {
        return new Date(b.date) - new Date(a.date)
    })
    if (currentList.length < 1) {
        let stocks = `<tr>
                        <td>Det er ingen artikler for denne aksjen</td>
                        <td>Returner til forrige side</td>
                        <td>Utvikler teamet</td>
                      </tr>`
        stocksTable.innerHTML += stocks;
    } else {
        let i = 0;
        while (i < currentList.length && i < 40) {
            let sentiment = "Nøytral"
            if (currentList[i].sentiment < 0) {
                sentiment = "Negativ"
            } else if (currentList[i].sentiment > 0) {
                sentiment = "Positiv"
            } else {
                sentiment = "Nøytral"
            }
            let stocks = `<tr>
                        <td>${currentList[i].title}</td>
                        <td><a href=${currentList[i].url} target="_blank" style="cursor: pointer">${currentList[i].url}</td>
                        <td>${currentList[i].publisher}</td>
                        <td>${currentList[i].date}</td>
                        <td onclick="showPopup(${[i]})" >${sentiment}</td>
                            
                      
                      </tr>`

            stocksTable.innerHTML += stocks;
            i ++;
        }
    }
    getValuesForGraph(currentList)
}

/*
    the scource for the modal used in the popupwindow: https://www.w3schools.com/howto/howto_css_modals.asp
*/

//creates the popup window
function createPopup(i) {
    popupdata.innerHTML = ''
    let pWords = currentList[i].positiveWords
    let nWords = currentList[i].negativeWords
    pWords = JSON.parse(JSON.stringify(pWords).split('\"').join('\" '))
    nWords = JSON.parse(JSON.stringify(nWords).split('\"').join('\" '))
    //pWords = pWords.split(',').join(', ')
    popupdata.innerHTML = `<div id="myModal" class="modal">
    <!-- Modal content -->
        <div class="modal-content">
       <span class="close" onclick="closePopup()">&times;</span>
        <p><li><b>Positive:</b><br> ${pWords}</li><li><b>Negative:</b><br> ${nWords}</li></p>
    </div>

</div>`

}


// makes the popupwindow visible
function showPopup(i) {
    createPopup(i)
    let modal = document.getElementById('myModal');

    $(".modal").css("display", "block");


}

// closes/hides the popup window
function closePopup() {
    $(".modal").css("display", "none");
}

function getValuesForGraph(list) {
    let graphSentiment = 0
    let nrOfArticlesThisDate = 0
    let xToGraph = []
    let yToGraph = []
    for (let i = 0; i < list.length; i++) {
        let lastDate = list[i].date
        for (let y = 0; y < list.length; y++) {
            if (list[y].date == lastDate) {
                nrOfArticlesThisDate++
                graphSentiment = graphSentiment + list[y].sentiment
            }
        }
        if (xToGraph.includes(lastDate)) {
            nrOfArticlesThisDate = 0
            graphSentiment = 0
        } else {
            let avgSentiment = graphSentiment / nrOfArticlesThisDate
            let sentiment = 0
            if (avgSentiment < -50) {
                sentiment = -1
            } else if (avgSentiment > 50) {
                sentiment = 1
            } else {
                sentiment = avgSentiment / 50
            }
            yToGraph.push(sentiment)
            xToGraph.push(lastDate)
            nrOfArticlesThisDate = 0
            graphSentiment = 0
        }
    }
    displayGraph(xToGraph, yToGraph)
}

function displayGraph(x, y) {
    articleGraph.innerHTML = '';
    let graphData = [{
        x: x,
        y: y,
        type: 'scatter',
    }];
    let =
    graphLayout = {
        title: 'Sentiment over tid',
        xaxis: {
            tickmode: 'linear',
            tickformat: '%b%d, %Y'
        },
        yaxis: {
            range: [-1, 1],
        }
    }
    Plotly.newPlot('sentiment_graph', graphData, graphLayout);
}